Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icblbc.F90
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icblbc.F90	(revision 3358)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icblbc.F90	(revision 3359)
@@ -19,10 +19,10 @@
    !!                       routines because they do not lie on regular jpi,jpj grids
    !!                       Processor exchanges are handled as in lib_mpp whenever icebergs step 
-   !!                       across boundary of interior domain (icbdi-icbei, icbdj-icbej)
+   !!                       across boundary of interior domain (nicbdi-nicbei, nicbdj-nicbej)
    !!                       so that iceberg does not exist in more than one processor
    !!                       North fold exchanges controlled by three arrays:
-   !!                          icbflddest - unique processor numbers that current one exchanges with
-   !!                          icbfldproc - processor number that current grid point exchanges with
-   !!                          icbfldpts  - packed i,j point in exchanging processor
+   !!                          nicbflddest - unique processor numbers that current one exchanges with
+   !!                          nicbfldproc - processor number that current grid point exchanges with
+   !!                          nicbfldpts  - packed i,j point in exchanging processor
    !!----------------------------------------------------------------------
 
@@ -56,6 +56,6 @@
    TYPE(buffer), POINTER           ::   obuffer_f=>NULL() , ibuffer_f=>NULL()
 
-   INTEGER, PARAMETER, PUBLIC      ::   delta_buf = 25             ! Size by which to increment buffers
-   INTEGER, PARAMETER, PUBLIC      ::   buffer_width = 15+nkounts  ! items to store for each berg
+   INTEGER, PARAMETER, PUBLIC      ::   pp_delta_buf = 25             ! Size by which to increment buffers
+   INTEGER, PARAMETER, PUBLIC      ::   pp_buffer_width = 15+nkounts  ! items to store for each berg
 
 #endif
@@ -88,5 +88,5 @@
       TYPE(iceberg), POINTER :: this
       TYPE(point)  , POINTER :: pt
-      INTEGER                :: ine
+      INTEGER                :: iine
 
       !! periodic east/west boundaries
@@ -98,9 +98,9 @@
          DO WHILE( ASSOCIATED(this) )
             pt => this%current_point
-            ine = INT( pt%xi + 0.5 )
-            IF( ine .GT. nimpp+icbei-1 ) THEN
-               pt%xi = icb_right + MOD(pt%xi, 1._wp ) - 1._wp
-            ELSE IF( ine .LT. nimpp+icbdi-1 ) THEN
-               pt%xi = icb_left + MOD(pt%xi, 1._wp )
+            iine = INT( pt%xi + 0.5 )
+            IF( iine .GT. nimpp+nicbei-1 ) THEN
+               pt%xi = ricb_right + MOD(pt%xi, 1._wp ) - 1._wp
+            ELSE IF( iine .LT. nimpp+nicbdi-1 ) THEN
+               pt%xi = ricb_left + MOD(pt%xi, 1._wp )
             ENDIF
             this => this%next
@@ -136,22 +136,22 @@
       TYPE(iceberg), POINTER :: this
       TYPE(point)  , POINTER :: pt
-      INTEGER                :: ine, jne, kpts
-      INTEGER                :: jiglo, jjglo
+      INTEGER                :: iine, ijne, ipts
+      INTEGER                :: iiglo, ijglo
 
       this => first_berg
       DO WHILE( ASSOCIATED(this) )
          pt => this%current_point
-         jne = INT( pt%yj + 0.5 )
-         IF( jne .GT. njmpp+icbej-1 ) THEN
+         ijne = INT( pt%yj + 0.5 )
+         IF( ijne .GT. njmpp+nicbej-1 ) THEN
             !
-            ine = INT( pt%xi + 0.5 )
-            kpts  = icbfldpts (ine-nimpp+1)
+            iine = INT( pt%xi + 0.5 )
+            ipts  = nicbfldpts (iine-nimpp+1)
             !
             ! moving across the cut line means both position and
             ! velocity must change
-            jjglo = INT( kpts/icbpack )
-            jiglo = kpts - icbpack*jjglo
-            pt%xi = jiglo - ( pt%xi - REAL(ine,wp) )
-            pt%yj = jjglo - ( pt%yj - REAL(jne,wp) )
+            ijglo = INT( ipts/nicbpack )
+            iiglo = ipts - nicbpack*ijglo
+            pt%xi = iiglo - ( pt%xi - REAL(iine,wp) )
+            pt%yj = ijglo - ( pt%yj - REAL(ijne,wp) )
             pt%uvel = -1._wp * pt%uvel
             pt%vvel = -1._wp * pt%vvel
@@ -181,40 +181,40 @@
       TYPE(iceberg)         , POINTER     :: tmpberg, this
       TYPE(point)           , POINTER     :: pt
-      INTEGER                             :: nbergs_to_send_e, nbergs_to_send_w
-      INTEGER                             :: nbergs_to_send_n, nbergs_to_send_s
-      INTEGER                             :: nbergs_rcvd_from_e, nbergs_rcvd_from_w
-      INTEGER                             :: nbergs_rcvd_from_n, nbergs_rcvd_from_s
-      INTEGER                             :: i, nbergs_start, nbergs_end
-      INTEGER                             :: ine, jne
-      INTEGER                             :: pe_N, pe_S, pe_W, pe_E
-      REAL(wp), DIMENSION(2)              :: ewbergs, webergs, nsbergs, snbergs
-      INTEGER                             :: ml_req1, ml_req2, ml_req3, ml_req4
-      INTEGER                             :: ml_req5, ml_req6, ml_req7, ml_req8, ml_err
-      INTEGER, DIMENSION(MPI_STATUS_SIZE) :: ml_stat
+      INTEGER                             :: ibergs_to_send_e, ibergs_to_send_w
+      INTEGER                             :: ibergs_to_send_n, ibergs_to_send_s
+      INTEGER                             :: ibergs_rcvd_from_e, ibergs_rcvd_from_w
+      INTEGER                             :: ibergs_rcvd_from_n, ibergs_rcvd_from_s
+      INTEGER                             :: i, ibergs_start, ibergs_end
+      INTEGER                             :: iine, ijne
+      INTEGER                             :: ipe_N, ipe_S, ipe_W, ipe_E
+      REAL(wp), DIMENSION(2)              :: zewbergs, zwebergs, znsbergs, zsnbergs
+      INTEGER                             :: iml_req1, iml_req2, iml_req3, iml_req4
+      INTEGER                             :: iml_req5, iml_req6, iml_req7, iml_req8, iml_err
+      INTEGER, DIMENSION(MPI_STATUS_SIZE) :: iml_stat
 
       ! set up indices of neighbouring processors
-      pe_N = -1
-      pe_S = -1
-      pe_W = -1
-      pe_E = -1
-      IF( nbondi .EQ.  0 .OR. nbondi .EQ. 1) pe_W = nowe
-      IF( nbondi .EQ. -1 .OR. nbondi .EQ. 0) pe_E = noea
-      IF( nbondj .EQ.  0 .OR. nbondj .EQ. 1) pe_S = noso
-      IF( nbondj .EQ. -1 .OR. nbondj .EQ. 0) pe_N = nono
+      ipe_N = -1
+      ipe_S = -1
+      ipe_W = -1
+      ipe_E = -1
+      IF( nbondi .EQ.  0 .OR. nbondi .EQ. 1) ipe_W = nowe
+      IF( nbondi .EQ. -1 .OR. nbondi .EQ. 0) ipe_E = noea
+      IF( nbondj .EQ.  0 .OR. nbondj .EQ. 1) ipe_S = noso
+      IF( nbondj .EQ. -1 .OR. nbondj .EQ. 0) ipe_N = nono
       !
       ! at northern line of processors with north fold handle bergs differently
-      IF( npolj > 0 ) pe_N = -1
+      IF( npolj > 0 ) ipe_N = -1
 
       ! if there's only one processor in x direction then don't let mpp try to handle periodicity
       IF( jpni == 1 ) THEN
-         pe_E = -1
-         pe_W = -1
+         ipe_E = -1
+         ipe_W = -1
       ENDIF
 
       IF( nn_verbose_level >= 2 ) THEN
-         WRITE(numicb,*) 'processor west  : ', pe_W
-         WRITE(numicb,*) 'processor east  : ', pe_E
-         WRITE(numicb,*) 'processor north : ', pe_N
-         WRITE(numicb,*) 'processor south : ', pe_S
+         WRITE(numicb,*) 'processor west  : ', ipe_W
+         WRITE(numicb,*) 'processor east  : ', ipe_E
+         WRITE(numicb,*) 'processor north : ', ipe_N
+         WRITE(numicb,*) 'processor south : ', ipe_S
          WRITE(numicb,*) 'processor nimpp : ', nimpp
          WRITE(numicb,*) 'processor njmpp : ', njmpp
@@ -234,15 +234,15 @@
       IF( nn_verbose_level > 0 ) THEN
          ! store the number of icebergs on this processor at start
-         nbergs_start = count_bergs()
-      ENDIF
-
-      nbergs_to_send_e = 0
-      nbergs_to_send_w = 0
-      nbergs_to_send_n = 0
-      nbergs_to_send_s = 0
-      nbergs_rcvd_from_e = 0
-      nbergs_rcvd_from_w = 0
-      nbergs_rcvd_from_n = 0
-      nbergs_rcvd_from_s = 0
+         ibergs_start = count_bergs()
+      ENDIF
+
+      ibergs_to_send_e = 0
+      ibergs_to_send_w = 0
+      ibergs_to_send_n = 0
+      ibergs_to_send_s = 0
+      ibergs_rcvd_from_e = 0
+      ibergs_rcvd_from_w = 0
+      ibergs_rcvd_from_n = 0
+      ibergs_rcvd_from_s = 0
 
       ! Find number of bergs that headed east/west
@@ -251,30 +251,30 @@
          DO WHILE (ASSOCIATED(this))
             pt => this%current_point
-            ine = INT( pt%xi + 0.5 )
-            IF( pe_E >= 0 .AND. ine .GT. nimpp+icbei-1 ) THEN
+            iine = INT( pt%xi + 0.5 )
+            IF( ipe_E >= 0 .AND. iine .GT. nimpp+nicbei-1 ) THEN
                tmpberg => this
                this => this%next
-               nbergs_to_send_e = nbergs_to_send_e + 1
+               ibergs_to_send_e = ibergs_to_send_e + 1
                IF( nn_verbose_level >= 4 ) THEN
-                  WRITE(numicb,*) 'bergstep ',ktberg,' packing berg ',tmpberg%number(:),' for transfer to east'
+                  WRITE(numicb,*) 'bergstep ',nktberg,' packing berg ',tmpberg%number(:),' for transfer to east'
                   CALL flush( numicb )
                ENDIF
                ! deal with periodic case
-               tmpberg%current_point%xi = icb_right + MOD(tmpberg%current_point%xi, 1._wp ) - 1._wp
+               tmpberg%current_point%xi = ricb_right + MOD(tmpberg%current_point%xi, 1._wp ) - 1._wp
                ! now pack it into buffer and delete from list
-               CALL pack_berg_into_buffer( tmpberg, obuffer_e, nbergs_to_send_e)
+               CALL pack_berg_into_buffer( tmpberg, obuffer_e, ibergs_to_send_e)
                CALL delete_iceberg_from_list(first_berg, tmpberg)
-            ELSE IF( pe_W >= 0 .AND. ine .LT. nimpp+icbdi-1 ) THEN
+            ELSE IF( ipe_W >= 0 .AND. iine .LT. nimpp+nicbdi-1 ) THEN
                tmpberg => this
                this => this%next
-               nbergs_to_send_w = nbergs_to_send_w + 1
+               ibergs_to_send_w = ibergs_to_send_w + 1
                IF( nn_verbose_level >= 4 ) THEN
-                  WRITE(numicb,*) 'bergstep ',ktberg,' packing berg ',tmpberg%number(:),' for transfer to west'
+                  WRITE(numicb,*) 'bergstep ',nktberg,' packing berg ',tmpberg%number(:),' for transfer to west'
                   CALL flush( numicb )
                ENDIF
                ! deal with periodic case
-               tmpberg%current_point%xi = icb_left + MOD(tmpberg%current_point%xi, 1._wp )
+               tmpberg%current_point%xi = ricb_left + MOD(tmpberg%current_point%xi, 1._wp )
                ! now pack it into buffer and delete from list
-               CALL pack_berg_into_buffer( tmpberg, obuffer_w, nbergs_to_send_w)
+               CALL pack_berg_into_buffer( tmpberg, obuffer_w, ibergs_to_send_w)
                CALL delete_iceberg_from_list(first_berg, tmpberg)
             ELSE
@@ -284,5 +284,5 @@
       ENDIF
       if( nn_verbose_level >= 3) then
-         write(numicb,*) 'bergstep ',ktberg,' send ew: ', nbergs_to_send_e, nbergs_to_send_w
+         write(numicb,*) 'bergstep ',nktberg,' send ew: ', ibergs_to_send_e, ibergs_to_send_w
          call flush(numicb)
       endif
@@ -295,29 +295,29 @@
       SELECT CASE ( nbondi )
       CASE( -1 )
-         webergs(1) = nbergs_to_send_e
-         CALL mppsend( 12, webergs(1), 1, pe_E, ml_req1)
-         CALL mpprecv( 11, ewbergs(2), 1 )
-         IF( l_isend ) CALL mpi_wait( ml_req1, ml_stat, ml_err )
-         nbergs_rcvd_from_e = INT( ewbergs(2) )
+         zwebergs(1) = ibergs_to_send_e
+         CALL mppsend( 12, zwebergs(1), 1, ipe_E, iml_req1)
+         CALL mpprecv( 11, zewbergs(2), 1 )
+         IF( l_isend ) CALL mpi_wait( iml_req1, iml_stat, iml_err )
+         ibergs_rcvd_from_e = INT( zewbergs(2) )
       CASE(  0 )
-         ewbergs(1) = nbergs_to_send_w
-         webergs(1) = nbergs_to_send_e
-         CALL mppsend( 11, ewbergs(1), 1, pe_W, ml_req2)
-         CALL mppsend( 12, webergs(1), 1, pe_E, ml_req3)
-         CALL mpprecv( 11, ewbergs(2), 1 )
-         CALL mpprecv( 12, webergs(2), 1 )
-         IF( l_isend ) CALL mpi_wait( ml_req2, ml_stat, ml_err )
-         IF( l_isend ) CALL mpi_wait( ml_req3, ml_stat, ml_err )
-         nbergs_rcvd_from_e = INT( ewbergs(2) )
-         nbergs_rcvd_from_w = INT( webergs(2) )
+         zewbergs(1) = ibergs_to_send_w
+         zwebergs(1) = ibergs_to_send_e
+         CALL mppsend( 11, zewbergs(1), 1, ipe_W, iml_req2)
+         CALL mppsend( 12, zwebergs(1), 1, ipe_E, iml_req3)
+         CALL mpprecv( 11, zewbergs(2), 1 )
+         CALL mpprecv( 12, zwebergs(2), 1 )
+         IF( l_isend ) CALL mpi_wait( iml_req2, iml_stat, iml_err )
+         IF( l_isend ) CALL mpi_wait( iml_req3, iml_stat, iml_err )
+         ibergs_rcvd_from_e = INT( zewbergs(2) )
+         ibergs_rcvd_from_w = INT( zwebergs(2) )
       CASE(  1 )
-         ewbergs(1) = nbergs_to_send_w
-         CALL mppsend( 11, ewbergs(1), 1, pe_W, ml_req4)
-         CALL mpprecv( 12, webergs(2), 1 )
-         IF( l_isend ) CALL mpi_wait( ml_req4, ml_stat, ml_err )
-         nbergs_rcvd_from_w = INT( webergs(2) )
+         zewbergs(1) = ibergs_to_send_w
+         CALL mppsend( 11, zewbergs(1), 1, ipe_W, iml_req4)
+         CALL mpprecv( 12, zwebergs(2), 1 )
+         IF( l_isend ) CALL mpi_wait( iml_req4, iml_stat, iml_err )
+         ibergs_rcvd_from_w = INT( zwebergs(2) )
       END SELECT
       if( nn_verbose_level >= 3) then
-         write(numicb,*) 'bergstep ',ktberg,' recv ew: ', nbergs_rcvd_from_w, nbergs_rcvd_from_e
+         write(numicb,*) 'bergstep ',nktberg,' recv ew: ', ibergs_rcvd_from_w, ibergs_rcvd_from_e
          call flush(numicb)
       endif
@@ -325,13 +325,13 @@
       SELECT CASE ( nbondi )
       CASE( -1 )
-         IF( nbergs_to_send_e > 0 ) CALL mppsend( 14, obuffer_e%data, nbergs_to_send_e*buffer_width, pe_E, ml_req1 )
-         IF( nbergs_rcvd_from_e > 0 ) THEN
-            CALL increase_ibuffer(ibuffer_e, nbergs_rcvd_from_e)
-            CALL mpprecv( 13, ibuffer_e%data, nbergs_rcvd_from_e*buffer_width )
-         ENDIF
-         IF( nbergs_to_send_e > 0 .AND. l_isend ) CALL mpi_wait( ml_req1, ml_stat, ml_err )
-         DO i = 1, nbergs_rcvd_from_e
+         IF( ibergs_to_send_e > 0 ) CALL mppsend( 14, obuffer_e%data, ibergs_to_send_e*pp_buffer_width, ipe_E, iml_req1 )
+         IF( ibergs_rcvd_from_e > 0 ) THEN
+            CALL increase_ibuffer(ibuffer_e, ibergs_rcvd_from_e)
+            CALL mpprecv( 13, ibuffer_e%data, ibergs_rcvd_from_e*pp_buffer_width )
+         ENDIF
+         IF( ibergs_to_send_e > 0 .AND. l_isend ) CALL mpi_wait( iml_req1, iml_stat, iml_err )
+         DO i = 1, ibergs_rcvd_from_e
             IF( nn_verbose_level >= 4 ) THEN
-               WRITE(numicb,*) 'bergstep ',ktberg,' unpacking berg ',INT(ibuffer_e%data(16,i)),' from east'
+               WRITE(numicb,*) 'bergstep ',nktberg,' unpacking berg ',INT(ibuffer_e%data(16,i)),' from east'
                CALL flush( numicb )
             ENDIF
@@ -339,26 +339,26 @@
          ENDDO
       CASE(  0 )
-         IF( nbergs_to_send_w > 0 ) CALL mppsend( 13, obuffer_w%data, nbergs_to_send_w*buffer_width, pe_W, ml_req2 )
-         IF( nbergs_to_send_e > 0 ) CALL mppsend( 14, obuffer_e%data, nbergs_to_send_e*buffer_width, pe_E, ml_req3 )
-         IF( nbergs_rcvd_from_e > 0 ) THEN
-            CALL increase_ibuffer(ibuffer_e, nbergs_rcvd_from_e)
-            CALL mpprecv( 13, ibuffer_e%data, nbergs_rcvd_from_e*buffer_width )
-         ENDIF
-         IF( nbergs_rcvd_from_w > 0 ) THEN
-            CALL increase_ibuffer(ibuffer_w, nbergs_rcvd_from_w)
-            CALL mpprecv( 14, ibuffer_w%data, nbergs_rcvd_from_w*buffer_width )
-         ENDIF
-         IF( nbergs_to_send_w > 0 .AND. l_isend ) CALL mpi_wait( ml_req2, ml_stat, ml_err )
-         IF( nbergs_to_send_e > 0 .AND. l_isend ) CALL mpi_wait( ml_req3, ml_stat, ml_err )
-         DO i = 1, nbergs_rcvd_from_e
+         IF( ibergs_to_send_w > 0 ) CALL mppsend( 13, obuffer_w%data, ibergs_to_send_w*pp_buffer_width, ipe_W, iml_req2 )
+         IF( ibergs_to_send_e > 0 ) CALL mppsend( 14, obuffer_e%data, ibergs_to_send_e*pp_buffer_width, ipe_E, iml_req3 )
+         IF( ibergs_rcvd_from_e > 0 ) THEN
+            CALL increase_ibuffer(ibuffer_e, ibergs_rcvd_from_e)
+            CALL mpprecv( 13, ibuffer_e%data, ibergs_rcvd_from_e*pp_buffer_width )
+         ENDIF
+         IF( ibergs_rcvd_from_w > 0 ) THEN
+            CALL increase_ibuffer(ibuffer_w, ibergs_rcvd_from_w)
+            CALL mpprecv( 14, ibuffer_w%data, ibergs_rcvd_from_w*pp_buffer_width )
+         ENDIF
+         IF( ibergs_to_send_w > 0 .AND. l_isend ) CALL mpi_wait( iml_req2, iml_stat, iml_err )
+         IF( ibergs_to_send_e > 0 .AND. l_isend ) CALL mpi_wait( iml_req3, iml_stat, iml_err )
+         DO i = 1, ibergs_rcvd_from_e
             IF( nn_verbose_level >= 4 ) THEN
-               WRITE(numicb,*) 'bergstep ',ktberg,' unpacking berg ',INT(ibuffer_e%data(16,i)),' from east'
+               WRITE(numicb,*) 'bergstep ',nktberg,' unpacking berg ',INT(ibuffer_e%data(16,i)),' from east'
                CALL flush( numicb )
             ENDIF
             CALL unpack_berg_from_buffer(first_berg, ibuffer_e, i)
          ENDDO
-         DO i = 1, nbergs_rcvd_from_w
+         DO i = 1, ibergs_rcvd_from_w
             IF( nn_verbose_level >= 4 ) THEN
-               WRITE(numicb,*) 'bergstep ',ktberg,' unpacking berg ',INT(ibuffer_w%data(16,i)),' from west'
+               WRITE(numicb,*) 'bergstep ',nktberg,' unpacking berg ',INT(ibuffer_w%data(16,i)),' from west'
                CALL flush( numicb )
             ENDIF
@@ -366,13 +366,13 @@
          ENDDO
       CASE(  1 )
-         IF( nbergs_to_send_w > 0 ) CALL mppsend( 13, obuffer_w%data, nbergs_to_send_w*buffer_width, pe_W, ml_req4 )
-         IF( nbergs_rcvd_from_w > 0 ) THEN
-            CALL increase_ibuffer(ibuffer_w, nbergs_rcvd_from_w)
-            CALL mpprecv( 14, ibuffer_w%data, nbergs_rcvd_from_w*buffer_width )
-         ENDIF
-         IF( nbergs_to_send_w > 0 .AND. l_isend ) CALL mpi_wait( ml_req4, ml_stat, ml_err )
-         DO i = 1, nbergs_rcvd_from_w
+         IF( ibergs_to_send_w > 0 ) CALL mppsend( 13, obuffer_w%data, ibergs_to_send_w*pp_buffer_width, ipe_W, iml_req4 )
+         IF( ibergs_rcvd_from_w > 0 ) THEN
+            CALL increase_ibuffer(ibuffer_w, ibergs_rcvd_from_w)
+            CALL mpprecv( 14, ibuffer_w%data, ibergs_rcvd_from_w*pp_buffer_width )
+         ENDIF
+         IF( ibergs_to_send_w > 0 .AND. l_isend ) CALL mpi_wait( iml_req4, iml_stat, iml_err )
+         DO i = 1, ibergs_rcvd_from_w
             IF( nn_verbose_level >= 4 ) THEN
-               WRITE(numicb,*) 'bergstep ',ktberg,' unpacking berg ',INT(ibuffer_w%data(16,i)),' from west'
+               WRITE(numicb,*) 'bergstep ',nktberg,' unpacking berg ',INT(ibuffer_w%data(16,i)),' from west'
                CALL flush( numicb )
             ENDIF
@@ -390,24 +390,24 @@
          DO WHILE (ASSOCIATED(this))
             pt => this%current_point
-            jne = INT( pt%yj + 0.5 )
-            IF( pe_N >= 0 .AND. jne .GT. njmpp+icbej-1 ) THEN
+            ijne = INT( pt%yj + 0.5 )
+            IF( ipe_N >= 0 .AND. ijne .GT. njmpp+nicbej-1 ) THEN
                tmpberg => this
                this => this%next
-               nbergs_to_send_n = nbergs_to_send_n + 1
+               ibergs_to_send_n = ibergs_to_send_n + 1
                IF( nn_verbose_level >= 4 ) THEN
-                  WRITE(numicb,*) 'bergstep ',ktberg,' packing berg ',tmpberg%number(:),' for transfer to north'
+                  WRITE(numicb,*) 'bergstep ',nktberg,' packing berg ',tmpberg%number(:),' for transfer to north'
                   CALL flush( numicb )
                ENDIF
-               CALL pack_berg_into_buffer( tmpberg, obuffer_n, nbergs_to_send_n)
+               CALL pack_berg_into_buffer( tmpberg, obuffer_n, ibergs_to_send_n)
                CALL delete_iceberg_from_list(first_berg, tmpberg)
-            ELSE IF( pe_S >= 0 .AND. jne .LT. njmpp+icbdj-1 ) THEN
+            ELSE IF( ipe_S >= 0 .AND. ijne .LT. njmpp+nicbdj-1 ) THEN
                tmpberg => this
                this => this%next
-               nbergs_to_send_s = nbergs_to_send_s + 1
+               ibergs_to_send_s = ibergs_to_send_s + 1
                IF( nn_verbose_level >= 4 ) THEN
-                  WRITE(numicb,*) 'bergstep ',ktberg,' packing berg ',tmpberg%number(:),' for transfer to south'
+                  WRITE(numicb,*) 'bergstep ',nktberg,' packing berg ',tmpberg%number(:),' for transfer to south'
                   CALL flush( numicb )
                ENDIF
-               CALL pack_berg_into_buffer( tmpberg, obuffer_s, nbergs_to_send_s)
+               CALL pack_berg_into_buffer( tmpberg, obuffer_s, ibergs_to_send_s)
                CALL delete_iceberg_from_list(first_berg, tmpberg)
             ELSE
@@ -417,5 +417,5 @@
       ENDIF
       if( nn_verbose_level >= 3) then
-         write(numicb,*) 'bergstep ',ktberg,' send ns: ', nbergs_to_send_n, nbergs_to_send_s
+         write(numicb,*) 'bergstep ',nktberg,' send ns: ', ibergs_to_send_n, ibergs_to_send_s
          call flush(numicb)
       endif
@@ -426,29 +426,29 @@
       SELECT CASE ( nbondj )
       CASE( -1 )
-         snbergs(1) = nbergs_to_send_n
-         CALL mppsend( 16, snbergs(1), 1, pe_N, ml_req1)
-         CALL mpprecv( 15, nsbergs(2), 1 )
-         IF( l_isend ) CALL mpi_wait( ml_req1, ml_stat, ml_err )
-         nbergs_rcvd_from_n = INT( nsbergs(2) )
+         zsnbergs(1) = ibergs_to_send_n
+         CALL mppsend( 16, zsnbergs(1), 1, ipe_N, iml_req1)
+         CALL mpprecv( 15, znsbergs(2), 1 )
+         IF( l_isend ) CALL mpi_wait( iml_req1, iml_stat, iml_err )
+         ibergs_rcvd_from_n = INT( znsbergs(2) )
       CASE(  0 )
-         nsbergs(1) = nbergs_to_send_s
-         snbergs(1) = nbergs_to_send_n
-         CALL mppsend( 15, nsbergs(1), 1, pe_S, ml_req2)
-         CALL mppsend( 16, snbergs(1), 1, pe_N, ml_req3)
-         CALL mpprecv( 15, nsbergs(2), 1 )
-         CALL mpprecv( 16, snbergs(2), 1 )
-         IF( l_isend ) CALL mpi_wait( ml_req2, ml_stat, ml_err )
-         IF( l_isend ) CALL mpi_wait( ml_req3, ml_stat, ml_err )
-         nbergs_rcvd_from_n = INT( nsbergs(2) )
-         nbergs_rcvd_from_s = INT( snbergs(2) )
+         znsbergs(1) = ibergs_to_send_s
+         zsnbergs(1) = ibergs_to_send_n
+         CALL mppsend( 15, znsbergs(1), 1, ipe_S, iml_req2)
+         CALL mppsend( 16, zsnbergs(1), 1, ipe_N, iml_req3)
+         CALL mpprecv( 15, znsbergs(2), 1 )
+         CALL mpprecv( 16, zsnbergs(2), 1 )
+         IF( l_isend ) CALL mpi_wait( iml_req2, iml_stat, iml_err )
+         IF( l_isend ) CALL mpi_wait( iml_req3, iml_stat, iml_err )
+         ibergs_rcvd_from_n = INT( znsbergs(2) )
+         ibergs_rcvd_from_s = INT( zsnbergs(2) )
       CASE(  1 )
-         nsbergs(1) = nbergs_to_send_s
-         CALL mppsend( 15, nsbergs(1), 1, pe_S, ml_req4)
-         CALL mpprecv( 16, snbergs(2), 1 )
-         IF( l_isend ) CALL mpi_wait( ml_req4, ml_stat, ml_err )
-         nbergs_rcvd_from_s = INT( snbergs(2) )
+         znsbergs(1) = ibergs_to_send_s
+         CALL mppsend( 15, znsbergs(1), 1, ipe_S, iml_req4)
+         CALL mpprecv( 16, zsnbergs(2), 1 )
+         IF( l_isend ) CALL mpi_wait( iml_req4, iml_stat, iml_err )
+         ibergs_rcvd_from_s = INT( zsnbergs(2) )
       END SELECT
       if( nn_verbose_level >= 3) then
-         write(numicb,*) 'bergstep ',ktberg,' recv ns: ', nbergs_rcvd_from_s, nbergs_rcvd_from_n
+         write(numicb,*) 'bergstep ',nktberg,' recv ns: ', ibergs_rcvd_from_s, ibergs_rcvd_from_n
          call flush(numicb)
       endif
@@ -456,13 +456,13 @@
       SELECT CASE ( nbondj )
       CASE( -1 )
-         IF( nbergs_to_send_n > 0 ) CALL mppsend( 18, obuffer_n%data, nbergs_to_send_n*buffer_width, pe_N, ml_req1 )
-         IF( nbergs_rcvd_from_n > 0 ) THEN
-            CALL increase_ibuffer(ibuffer_n, nbergs_rcvd_from_n)
-            CALL mpprecv( 17, ibuffer_n%data, nbergs_rcvd_from_n*buffer_width )
-         ENDIF
-         IF( nbergs_to_send_n > 0 .AND. l_isend ) CALL mpi_wait( ml_req1, ml_stat, ml_err )
-         DO i = 1, nbergs_rcvd_from_n
+         IF( ibergs_to_send_n > 0 ) CALL mppsend( 18, obuffer_n%data, ibergs_to_send_n*pp_buffer_width, ipe_N, iml_req1 )
+         IF( ibergs_rcvd_from_n > 0 ) THEN
+            CALL increase_ibuffer(ibuffer_n, ibergs_rcvd_from_n)
+            CALL mpprecv( 17, ibuffer_n%data, ibergs_rcvd_from_n*pp_buffer_width )
+         ENDIF
+         IF( ibergs_to_send_n > 0 .AND. l_isend ) CALL mpi_wait( iml_req1, iml_stat, iml_err )
+         DO i = 1, ibergs_rcvd_from_n
             IF( nn_verbose_level >= 4 ) THEN
-               WRITE(numicb,*) 'bergstep ',ktberg,' unpacking berg ',INT(ibuffer_n%data(16,i)),' from north'
+               WRITE(numicb,*) 'bergstep ',nktberg,' unpacking berg ',INT(ibuffer_n%data(16,i)),' from north'
                CALL flush( numicb )
             ENDIF
@@ -470,26 +470,26 @@
          ENDDO
       CASE(  0 )
-         IF( nbergs_to_send_s > 0 ) CALL mppsend( 17, obuffer_s%data, nbergs_to_send_s*buffer_width, pe_S, ml_req2 )
-         IF( nbergs_to_send_n > 0 ) CALL mppsend( 18, obuffer_n%data, nbergs_to_send_n*buffer_width, pe_N, ml_req3 )
-         IF( nbergs_rcvd_from_n > 0 ) THEN
-            CALL increase_ibuffer(ibuffer_n, nbergs_rcvd_from_n)
-            CALL mpprecv( 17, ibuffer_n%data, nbergs_rcvd_from_n*buffer_width )
-         ENDIF
-         IF( nbergs_rcvd_from_s > 0 ) THEN
-            CALL increase_ibuffer(ibuffer_s, nbergs_rcvd_from_s)
-            CALL mpprecv( 18, ibuffer_s%data, nbergs_rcvd_from_s*buffer_width )
-         ENDIF
-         IF( nbergs_to_send_s > 0 .AND. l_isend ) CALL mpi_wait( ml_req2, ml_stat, ml_err )
-         IF( nbergs_to_send_n > 0 .AND. l_isend ) CALL mpi_wait( ml_req3, ml_stat, ml_err )
-         DO i = 1, nbergs_rcvd_from_n
+         IF( ibergs_to_send_s > 0 ) CALL mppsend( 17, obuffer_s%data, ibergs_to_send_s*pp_buffer_width, ipe_S, iml_req2 )
+         IF( ibergs_to_send_n > 0 ) CALL mppsend( 18, obuffer_n%data, ibergs_to_send_n*pp_buffer_width, ipe_N, iml_req3 )
+         IF( ibergs_rcvd_from_n > 0 ) THEN
+            CALL increase_ibuffer(ibuffer_n, ibergs_rcvd_from_n)
+            CALL mpprecv( 17, ibuffer_n%data, ibergs_rcvd_from_n*pp_buffer_width )
+         ENDIF
+         IF( ibergs_rcvd_from_s > 0 ) THEN
+            CALL increase_ibuffer(ibuffer_s, ibergs_rcvd_from_s)
+            CALL mpprecv( 18, ibuffer_s%data, ibergs_rcvd_from_s*pp_buffer_width )
+         ENDIF
+         IF( ibergs_to_send_s > 0 .AND. l_isend ) CALL mpi_wait( iml_req2, iml_stat, iml_err )
+         IF( ibergs_to_send_n > 0 .AND. l_isend ) CALL mpi_wait( iml_req3, iml_stat, iml_err )
+         DO i = 1, ibergs_rcvd_from_n
             IF( nn_verbose_level >= 4 ) THEN
-               WRITE(numicb,*) 'bergstep ',ktberg,' unpacking berg ',INT(ibuffer_n%data(16,i)),' from north'
+               WRITE(numicb,*) 'bergstep ',nktberg,' unpacking berg ',INT(ibuffer_n%data(16,i)),' from north'
                CALL flush( numicb )
             ENDIF
             CALL unpack_berg_from_buffer(first_berg, ibuffer_n, i)
          ENDDO
-         DO i = 1, nbergs_rcvd_from_s
+         DO i = 1, ibergs_rcvd_from_s
             IF( nn_verbose_level >= 4 ) THEN
-               WRITE(numicb,*) 'bergstep ',ktberg,' unpacking berg ',INT(ibuffer_s%data(16,i)),' from south'
+               WRITE(numicb,*) 'bergstep ',nktberg,' unpacking berg ',INT(ibuffer_s%data(16,i)),' from south'
                CALL flush( numicb )
             ENDIF
@@ -497,13 +497,13 @@
          ENDDO
       CASE(  1 )
-         IF( nbergs_to_send_s > 0 ) CALL mppsend( 17, obuffer_s%data, nbergs_to_send_s*buffer_width, pe_S, ml_req4 )
-         IF( nbergs_rcvd_from_s > 0 ) THEN
-            CALL increase_ibuffer(ibuffer_s, nbergs_rcvd_from_s)
-            CALL mpprecv( 18, ibuffer_s%data, nbergs_rcvd_from_s*buffer_width )
-         ENDIF
-         IF( nbergs_to_send_s > 0 .AND. l_isend ) CALL mpi_wait( ml_req4, ml_stat, ml_err )
-         DO i = 1, nbergs_rcvd_from_s
+         IF( ibergs_to_send_s > 0 ) CALL mppsend( 17, obuffer_s%data, ibergs_to_send_s*pp_buffer_width, ipe_S, iml_req4 )
+         IF( ibergs_rcvd_from_s > 0 ) THEN
+            CALL increase_ibuffer(ibuffer_s, ibergs_rcvd_from_s)
+            CALL mpprecv( 18, ibuffer_s%data, ibergs_rcvd_from_s*pp_buffer_width )
+         ENDIF
+         IF( ibergs_to_send_s > 0 .AND. l_isend ) CALL mpi_wait( iml_req4, iml_stat, iml_err )
+         DO i = 1, ibergs_rcvd_from_s
             IF( nn_verbose_level >= 4 ) THEN
-               WRITE(numicb,*) 'bergstep ',ktberg,' unpacking berg ',INT(ibuffer_s%data(16,i)),' from south'
+               WRITE(numicb,*) 'bergstep ',nktberg,' unpacking berg ',INT(ibuffer_s%data(16,i)),' from south'
                CALL flush( numicb )
             ENDIF
